package com.jscape.inet.ssh.protocol.v2.marshaling;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.StringCodec;
import com.jscape.inet.ssh.protocol.v2.messages.SshMsgUserAuthBanner;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshMsgUserAuthBannerCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        String message = StringCodec.readUtf8Value(in);
        String languageTag = StringCodec.readUsAsciiValue(in);

        return new SshMsgUserAuthBanner(message, languageTag);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshMsgUserAuthBanner message = (SshMsgUserAuthBanner) value;
        StringCodec.writeUtf8Value(message.message, out);
        StringCodec.writeUsAsciiValue(message.languageTag, out);
    }
}
